#include <iostream>
#include <random>
#include <chrono>
#include "HashTableInt.h"
using namespace std;

int main() {
	default_random_engine generator(
		chrono::system_clock::now().time_since_epoch().count());
	uniform_int_distribution<int> distribution(1,10000);

	unsigned int maxBucket = 17;
	HashTableInt ht(maxBucket);
	for (int i = 0; i < 2000; i++) {
		int num = distribution(generator);
		ht.Insert(num);
	}

	int hits = 0;
	for (int i = 0; i < 2000; i++) {
		int num = distribution(generator);
		if (ht.Contains(num)) hits++;
	}

	cout << "Treffer: " << hits << endl;

	return 0;
}
