#include <iostream>
#include <random>
#include <chrono>
using namespace std;

void Swap(int& a, int& b) {
	int c = b; b = a; a = c;
}

void Merge(int const size, int a[], int b[]) {
	int* c = new int[2*size];

	// mischen
	int i = 0, j = 0;
	for (int k = 0; k < 2 * size; k++)
		if ((j == size) || (i < size && a[i] < b[j]))
			c[k] = a[i++];
		else
			c[k] = b[j++];
	// umkopieren
	for (int k = 0; k < size; k++) {
		a[k] = c[k];
		b[k] = c[k+size];
	}
	delete[] c;
}

void Msort(int const size, int a[]) {
	if (size == 2) {  // sortieren
		if (a[0] > a[1]) Swap(a[0], a[1]);
		return;
	}
	// teilen
	int k = size / 2;
	Msort(k, &a[0]);
	Msort(k, &a[k]);
	// mischen
	Merge(k, &a[0], &a[k]);
}

void Print(int const size, int a[]) {
	for (int i = 0; i < size; i++) {
		cout << a[i] << "\t";
		if ((i+1) % 8 == 0) cout << endl;
	}
	cout << endl;
}

int main() {
	default_random_engine gen(
		chrono::system_clock::now().time_since_epoch().count());
	uniform_int_distribution<int> distri(1,10000);
	int const size = 32;
	int a[size];

	for (int k = 0; k < size; k++) a[k] = distri(gen);

	Print(size, a);
	Msort(size, a);
	Print(size, a);
}
